---
title: "Things to do in DN42"
geekdocDescription: "Stuck for inspiration ?"
type: "docs"
geekdocAnchor: true
---

What can you do in DN42 ? Ultimately, you'll get out of DN42 what you put in to it,
but I've listed here a few ideas that may serve as inspiration and the spark an idea.

This is deliberately not a set of instructions or a guide and it's not a checklist of stuff you
must do.<br/>
If you are interested in something there is plenty of public information available on all these topics.

## Getting Started

- Read up on how Internet peering works, and the tools and protocols that are used
- Register your details in the DN42 registry
   - Do read the DN42 getting started guide
   - Do browse through the registry itself and use what other people did as examples
   - Do look through recent Pull Requests to see what is required and how to do it
- Join the mailing list and #dn42 on hackint
   - DN42 is a great community with many knowledgable members. You can learn a lot from what other
     people are doing, or the problems they have, as well as getting your own network working
- Get your first peer
  - use the peerfinder to find peers close to you, or ask on IRC
- ping something on DN42
- use a DN42 service

Congratulations, you're connected to DN42 !

## The Basics

- Get more peers
   - Add 4 or 5 different peers
      - having several peers prevents having a dependency on a single peer and adds redundancy
      - provides you with a variety of different routes
      - learn how different peers manage their networks
- How do you see which routes are being advertised and selected ?
  - Change route metrics and see how this influences selected routes
  - Optimise your routes across your peers
  - What is an optimal route anyway ?
- How is your network being distributed across DN42 ?
  - How do you find out ?
  - Change how your routes are advertised to peers to influence the routing to your network across DN42
- Set up DNS and resolve a host in the .dn42 hierarchy
- Set up your own DNS server
  - Register a domain; set up forward and reverse DNS
- Set up a blog/wiki and document your network
  - Make the pages available over DN42 and the Internet
- Add your network to the peerfinder
- Learn something new and add it to the DN42 Wiki

## Intermediate

- Secure your network
- Distribute DN42 routes to another, internal node
  - Learn how to use an IGP and iBGP
- Add two or more nodes to DN42 and peer with multiple AS
  - Distribute routes from all peers across the nodes in your network
- How do you decide which routes are 'best' across the network ?
  - Optimise your routes to DN42 
- How do you manage multiple entry points to your network ?
  - What do other networks see ?
  - How do other networks decide which node to route to ?
- Configure your network so that one node is preferred
  - Optimise how DN42 sees your network
- Add two or more nodes in different continents
  - Why is that different ?
  - How do you optimise your network now ?
- Implement ROA
- Implement BGP communities
- Help a new joiner connect to DN42
- Resolve someone elses DN42 problem
- Set up a looking glass
- Set up a service that can be used by the rest of the DN42 community
  - Make it a 'production' service, add HA, monitoring and alerting
  - Secure your service
  - Use the DN42 CA
  - Add it to the wiki

## Complex

- Connect multiple nodes to the same peer AS in different geographic locations
  - Optimise the routes to the AS
  - Optimise the routes that the peer AS has to you
- Monitor your network
  - How do you know it's working well ?
  - (what does 'working well' mean ?)
  - provide public metrics
- Create a virtual environmment to test changes
  - How do you make your virtual environment representative of DN42 ?
- Volunteer to help with DN42 core services
- System administration and automation
  - Patching and maintenance
  - Implement backups and DR
  - Automate the set up and configuration of your nodes
  - Automate adding peers
  
## Even more

- Make something new
  - What's the latest software or network trend ?
  - implement it and learn how to use it
- Make something experimental
  - Try out a cutting edge service or network technology and see if you can get it to work
  - What are the current challenges faced by the Internet ? How are they being solved ?
  - Can you replicate the problem and potential solutions in DN42 ?
- Make something social
  - Create and share a community resource
- Make something stable
  - Fine tune your network and nodes
  - DN42 changes all the time, how do you protect your network from other people breaking things ?
- Make something small
  - Take something huge (DNS, CDNs, gmail, distributed computing, serverless, AI ...)
    and shrink it down to your network, but using the same techniques as the global players to manage things
    - scale it up, and down
- Make something corporate
  - Replicate a multi-datacentre corporate/organisation design
  - Grab your next job based on your experience ;)
- Make it all again
  - There's more than one way to do it; rebuild your network using a different design
  - How can you rebuild everything whilst minising the impact to everyone else ?
  - What did you learn ? What works better now ? What is worse ?
  - How can you do it again better next time ?

## Final words

What can you do in DN42 ?

- Do whatever is fun and interesting for you
